const test = require('tape')
const nlp = require('../_lib')

test('prefix/infix/suffix basic', function(t) {
  let r = nlp('it is funny and weird')
  let m = r.match('/nny$/', true)
  t.equal(m.out('normal'), 'funny', 'suffix-match')
  m = r.match('/^fu/', true)
  t.equal(m.out('normal'), 'funny', 'prefix_match')
  m = r.match('/nn/', true)
  t.equal(m.out('normal'), 'funny', 'infix-match')

  m = r.match('/ff$/', true)
  t.equal(m.out('normal'), '', 'no-false-suffix')
  m = r.match('/^ff/', true)
  t.equal(m.out('normal'), '', 'no-false-prefix')
  m = r.match('/ff/', true)
  t.equal(m.out('normal'), '', 'no-false-infix')

  m = r.match('_', true)
  t.equal(m.out('normal'), '', 'no-throw1')
  m = r.match(' _ ', true)
  t.equal(m.out('normal'), '', 'no-throw2')
  m = r.match(' __ ', true)
  t.equal(m.out('normal'), '', 'no-throw3')
  m = r.match(' _ _ ', true)
  t.equal(m.out('normal'), '', 'no-throw4')

  m = r.match('/^w/', true)
  t.equal(m.out('normal'), 'weird', 'one-char-one-word')
  m = r.match('/r/', true)
  t.equal(m.out('normal'), 'weird', 'one-char-one-word2')
  m = r.match('/y$/', true)
  t.equal(m.out('normal'), 'funny', 'one-char-one-word3')

  t.end()
})
